# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from mir_msgs/BMSData.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class BMSData(genpy.Message):
  _md5sum = "64d9a6ee7004b0da6e7d451e7b57953b"
  _type = "mir_msgs/BMSData"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """float64 pack_voltage
float64 charge_current
float64 discharge_current
float64 state_of_charge
float64 remaining_time_to_full_charge
int32 remaining_capacity
int32 state_of_health
int32 DISCHARGING=1 #bit 0
int32 CHARGING=2    #bit 1
int32 OV=4         #bit 2 Over voltage
int32 UV=8          #bit 3 Under voltage
int32 COC=16         #bit 4 Charge over current
int32 DOC=32         #bit 5 Discharge over current
int32 DOT=64         #bit 6 Discharge over temperature
int32 DUT=128         #bit 7 Discharge under temperature
int32  SC=512         #bit 9
int32 COT=1024         #bit 10 Charge over temperature
int32 CUT=2048         #bit 11 Charge under temperature
int32 FW_STATUS_MSK=2031616 # to get Battery_Firmware_Status  do the following:
int32 FW_STATUS_SHIFT=16    # batt_fw_stat=(status_flags & FW_STATUS_MSK)>>FW_STATUS_SHIFT
int32 FW_UPD_OK=0                  #Battery firmware update finished OK.
int32 FW_UPD_RUNNING=1             #Battery firmware update running.
int32 FW_UPD_FAILED_BOOT=2         #Battery firmware update failed in Bootloader (Robot must not drive)
int32 FW_UPD_FAILED_APP=3          #Battery firmware update failed updating the application (Robot can drive with old FW)
int32 FW_UPD_FAILED_PARAM=4        #Battery firmware update failed uploading parameters (Robot can drive with old fw and parameters.)
int32 FW_STATUS_LOW_BATT=5         #Battery firmware update skipped battery too low or high (Robot can drive with old parameters.)
int32 FW_STATUS_FILE_CORRUPTED=6   #Battery firmware file corrupted (Robot can drive with old parameters.)
int32 FW_STATUS_CURRENT_TO_HIGH=7  #Battery firmware file corrupted (Robot can drive with old parameters.)
int32 FW_STATUS_NO_CAN=8           #Battery firmware update skipped no CAN communication (Robot can drive with old fw and parameters.)
int32 FW_BATTERY_IMBALANCE_HIGH=9  #Battery firmware update is enforced and the battery will be shut off by the new firmware
int32 status_flags
int32 temperature
uint32[] cell_voltage # In Mk2 robots and above the BMS provides data for 8 battery cells. 2Gen robots have BMS for 13 battery cells
uint32 cell_voltage_diff

string WST_serial

# Exteded diagnosticts for BMZ battery
uint32 bmz_flag # Flag for enabling extended diagnosticts
uint32 battery_type
uint32 BATT_TYPE_UNKNOWN=0      #type is unknown / no communucation
uint32 BATT_TYPE_BMZ=1          #BMZ battery
uint32 BATT_TYPE_WST=2          #WST battery
uint32 BATT_TYPE_SBS=3          #SBS battery
uint32 BATT_TYPE_SBS_SLIDE=4    #SBS SLIDE battery
uint32 BATT_TYPE_NO_BMS=255       #WST No BMS battery
float64 full_voltage
int32 full_capacity
int32 temperature2
int32 temperature_pcb
int32 cycle_count
int32 dsg_overcurrent_counter
int32 chg_overcurrent_counter
int32 hw_major
int32 hw_minor
int32 fw_major
int32 fw_minor
int32 fw_patch
int32 fw_parameters_ok
int32 rec_fw_major
int32 rec_fw_minor
int32 rec_fw_patch
int32 bl_major
int32 bl_minor
uint32 status_enabled
uint32 status_current_limitation
uint32 status_switch_off_warn1
uint32 status_switch_off_warn2
uint32 status_fully_discharged
uint32 status_nearly_discharged
uint32 status_chargefet_on
uint32 status_dischargefet_on
uint32 status_discharging
uint32 status_fully_charged
uint32 status_charging
uint32 status_temp_charging_err
uint32 status_cell_over_voltage
uint32 status_cell_under_voltage
uint32 status_charge_over_current
uint32 status_shortcircuit
uint32 status_discharge_over_current
float64 status_chargefet_voltage
float64 status_dischargefet_voltage
uint32 status_temp_discharging_err
uint32 status_charger_detected
uint32 mnfct_bms_revision
uint32 mnfct_asn_revision
uint32 mnfct_year
uint32 mnfct_week
uint32 mnfct_model
uint32 mnfct_serial
uint32 afe_i2c_error_count
uint32 app_error_count
uint32 fet_disable_state

float64 last_battery_msg_time

# SBS battery states
uint32 SBS_battery_status
uint32 SBS_battery_status_raw
uint32 SBS_InitState1=1
uint32 SBS_InitState2=2
uint32 SBS_InitState3=3
uint32 SBS_InitState4=4
uint32 SBS_Idle=5
uint32 SBS_Discharge=6
uint32 SBS_Charge=7
uint32 SBS_Fault=10
uint32 SBS_CriticalError=11
uint32 SBS_PrepareDeepsleep=99
uint32 SBS_Deepsleep=100

string SBS_serial_1
string SBS_serial_2

uint32 SBS_arti_nr_1
uint32 SBS_arti_nr_2
uint32 SBS_arti_nr_3

uint32 SBS_curr_flow_passive_state

# Overcurrent counters
uint8 CHG_OC1_Count
uint8 CHG_OC2_Count
uint8 DSG_OC1_Count
uint8 DSG_OC2_Count
uint8 DSG_OC3_Count
uint8 AFE_OC1_Count
uint8 AFE_OC2_Count
uint8 CHG_LatchClear_Count
uint8 DSG_LatchClear_Count

uint8 chg_oc_warning
uint8 dsg_oc_warning
"""
  # Pseudo-constants
  DISCHARGING = 1
  CHARGING = 2
  OV = 4
  UV = 8
  COC = 16
  DOC = 32
  DOT = 64
  DUT = 128
  SC = 512
  COT = 1024
  CUT = 2048
  FW_STATUS_MSK = 2031616
  FW_STATUS_SHIFT = 16
  FW_UPD_OK = 0
  FW_UPD_RUNNING = 1
  FW_UPD_FAILED_BOOT = 2
  FW_UPD_FAILED_APP = 3
  FW_UPD_FAILED_PARAM = 4
  FW_STATUS_LOW_BATT = 5
  FW_STATUS_FILE_CORRUPTED = 6
  FW_STATUS_CURRENT_TO_HIGH = 7
  FW_STATUS_NO_CAN = 8
  FW_BATTERY_IMBALANCE_HIGH = 9
  BATT_TYPE_UNKNOWN = 0
  BATT_TYPE_BMZ = 1
  BATT_TYPE_WST = 2
  BATT_TYPE_SBS = 3
  BATT_TYPE_SBS_SLIDE = 4
  BATT_TYPE_NO_BMS = 255
  SBS_InitState1 = 1
  SBS_InitState2 = 2
  SBS_InitState3 = 3
  SBS_InitState4 = 4
  SBS_Idle = 5
  SBS_Discharge = 6
  SBS_Charge = 7
  SBS_Fault = 10
  SBS_CriticalError = 11
  SBS_PrepareDeepsleep = 99
  SBS_Deepsleep = 100

  __slots__ = ['pack_voltage','charge_current','discharge_current','state_of_charge','remaining_time_to_full_charge','remaining_capacity','state_of_health','status_flags','temperature','cell_voltage','cell_voltage_diff','WST_serial','bmz_flag','battery_type','full_voltage','full_capacity','temperature2','temperature_pcb','cycle_count','dsg_overcurrent_counter','chg_overcurrent_counter','hw_major','hw_minor','fw_major','fw_minor','fw_patch','fw_parameters_ok','rec_fw_major','rec_fw_minor','rec_fw_patch','bl_major','bl_minor','status_enabled','status_current_limitation','status_switch_off_warn1','status_switch_off_warn2','status_fully_discharged','status_nearly_discharged','status_chargefet_on','status_dischargefet_on','status_discharging','status_fully_charged','status_charging','status_temp_charging_err','status_cell_over_voltage','status_cell_under_voltage','status_charge_over_current','status_shortcircuit','status_discharge_over_current','status_chargefet_voltage','status_dischargefet_voltage','status_temp_discharging_err','status_charger_detected','mnfct_bms_revision','mnfct_asn_revision','mnfct_year','mnfct_week','mnfct_model','mnfct_serial','afe_i2c_error_count','app_error_count','fet_disable_state','last_battery_msg_time','SBS_battery_status','SBS_battery_status_raw','SBS_serial_1','SBS_serial_2','SBS_arti_nr_1','SBS_arti_nr_2','SBS_arti_nr_3','SBS_curr_flow_passive_state','CHG_OC1_Count','CHG_OC2_Count','DSG_OC1_Count','DSG_OC2_Count','DSG_OC3_Count','AFE_OC1_Count','AFE_OC2_Count','CHG_LatchClear_Count','DSG_LatchClear_Count','chg_oc_warning','dsg_oc_warning']
  _slot_types = ['float64','float64','float64','float64','float64','int32','int32','int32','int32','uint32[]','uint32','string','uint32','uint32','float64','int32','int32','int32','int32','int32','int32','int32','int32','int32','int32','int32','int32','int32','int32','int32','int32','int32','uint32','uint32','uint32','uint32','uint32','uint32','uint32','uint32','uint32','uint32','uint32','uint32','uint32','uint32','uint32','uint32','uint32','float64','float64','uint32','uint32','uint32','uint32','uint32','uint32','uint32','uint32','uint32','uint32','uint32','float64','uint32','uint32','string','string','uint32','uint32','uint32','uint32','uint8','uint8','uint8','uint8','uint8','uint8','uint8','uint8','uint8','uint8','uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       pack_voltage,charge_current,discharge_current,state_of_charge,remaining_time_to_full_charge,remaining_capacity,state_of_health,status_flags,temperature,cell_voltage,cell_voltage_diff,WST_serial,bmz_flag,battery_type,full_voltage,full_capacity,temperature2,temperature_pcb,cycle_count,dsg_overcurrent_counter,chg_overcurrent_counter,hw_major,hw_minor,fw_major,fw_minor,fw_patch,fw_parameters_ok,rec_fw_major,rec_fw_minor,rec_fw_patch,bl_major,bl_minor,status_enabled,status_current_limitation,status_switch_off_warn1,status_switch_off_warn2,status_fully_discharged,status_nearly_discharged,status_chargefet_on,status_dischargefet_on,status_discharging,status_fully_charged,status_charging,status_temp_charging_err,status_cell_over_voltage,status_cell_under_voltage,status_charge_over_current,status_shortcircuit,status_discharge_over_current,status_chargefet_voltage,status_dischargefet_voltage,status_temp_discharging_err,status_charger_detected,mnfct_bms_revision,mnfct_asn_revision,mnfct_year,mnfct_week,mnfct_model,mnfct_serial,afe_i2c_error_count,app_error_count,fet_disable_state,last_battery_msg_time,SBS_battery_status,SBS_battery_status_raw,SBS_serial_1,SBS_serial_2,SBS_arti_nr_1,SBS_arti_nr_2,SBS_arti_nr_3,SBS_curr_flow_passive_state,CHG_OC1_Count,CHG_OC2_Count,DSG_OC1_Count,DSG_OC2_Count,DSG_OC3_Count,AFE_OC1_Count,AFE_OC2_Count,CHG_LatchClear_Count,DSG_LatchClear_Count,chg_oc_warning,dsg_oc_warning

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(BMSData, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.pack_voltage is None:
        self.pack_voltage = 0.
      if self.charge_current is None:
        self.charge_current = 0.
      if self.discharge_current is None:
        self.discharge_current = 0.
      if self.state_of_charge is None:
        self.state_of_charge = 0.
      if self.remaining_time_to_full_charge is None:
        self.remaining_time_to_full_charge = 0.
      if self.remaining_capacity is None:
        self.remaining_capacity = 0
      if self.state_of_health is None:
        self.state_of_health = 0
      if self.status_flags is None:
        self.status_flags = 0
      if self.temperature is None:
        self.temperature = 0
      if self.cell_voltage is None:
        self.cell_voltage = []
      if self.cell_voltage_diff is None:
        self.cell_voltage_diff = 0
      if self.WST_serial is None:
        self.WST_serial = ''
      if self.bmz_flag is None:
        self.bmz_flag = 0
      if self.battery_type is None:
        self.battery_type = 0
      if self.full_voltage is None:
        self.full_voltage = 0.
      if self.full_capacity is None:
        self.full_capacity = 0
      if self.temperature2 is None:
        self.temperature2 = 0
      if self.temperature_pcb is None:
        self.temperature_pcb = 0
      if self.cycle_count is None:
        self.cycle_count = 0
      if self.dsg_overcurrent_counter is None:
        self.dsg_overcurrent_counter = 0
      if self.chg_overcurrent_counter is None:
        self.chg_overcurrent_counter = 0
      if self.hw_major is None:
        self.hw_major = 0
      if self.hw_minor is None:
        self.hw_minor = 0
      if self.fw_major is None:
        self.fw_major = 0
      if self.fw_minor is None:
        self.fw_minor = 0
      if self.fw_patch is None:
        self.fw_patch = 0
      if self.fw_parameters_ok is None:
        self.fw_parameters_ok = 0
      if self.rec_fw_major is None:
        self.rec_fw_major = 0
      if self.rec_fw_minor is None:
        self.rec_fw_minor = 0
      if self.rec_fw_patch is None:
        self.rec_fw_patch = 0
      if self.bl_major is None:
        self.bl_major = 0
      if self.bl_minor is None:
        self.bl_minor = 0
      if self.status_enabled is None:
        self.status_enabled = 0
      if self.status_current_limitation is None:
        self.status_current_limitation = 0
      if self.status_switch_off_warn1 is None:
        self.status_switch_off_warn1 = 0
      if self.status_switch_off_warn2 is None:
        self.status_switch_off_warn2 = 0
      if self.status_fully_discharged is None:
        self.status_fully_discharged = 0
      if self.status_nearly_discharged is None:
        self.status_nearly_discharged = 0
      if self.status_chargefet_on is None:
        self.status_chargefet_on = 0
      if self.status_dischargefet_on is None:
        self.status_dischargefet_on = 0
      if self.status_discharging is None:
        self.status_discharging = 0
      if self.status_fully_charged is None:
        self.status_fully_charged = 0
      if self.status_charging is None:
        self.status_charging = 0
      if self.status_temp_charging_err is None:
        self.status_temp_charging_err = 0
      if self.status_cell_over_voltage is None:
        self.status_cell_over_voltage = 0
      if self.status_cell_under_voltage is None:
        self.status_cell_under_voltage = 0
      if self.status_charge_over_current is None:
        self.status_charge_over_current = 0
      if self.status_shortcircuit is None:
        self.status_shortcircuit = 0
      if self.status_discharge_over_current is None:
        self.status_discharge_over_current = 0
      if self.status_chargefet_voltage is None:
        self.status_chargefet_voltage = 0.
      if self.status_dischargefet_voltage is None:
        self.status_dischargefet_voltage = 0.
      if self.status_temp_discharging_err is None:
        self.status_temp_discharging_err = 0
      if self.status_charger_detected is None:
        self.status_charger_detected = 0
      if self.mnfct_bms_revision is None:
        self.mnfct_bms_revision = 0
      if self.mnfct_asn_revision is None:
        self.mnfct_asn_revision = 0
      if self.mnfct_year is None:
        self.mnfct_year = 0
      if self.mnfct_week is None:
        self.mnfct_week = 0
      if self.mnfct_model is None:
        self.mnfct_model = 0
      if self.mnfct_serial is None:
        self.mnfct_serial = 0
      if self.afe_i2c_error_count is None:
        self.afe_i2c_error_count = 0
      if self.app_error_count is None:
        self.app_error_count = 0
      if self.fet_disable_state is None:
        self.fet_disable_state = 0
      if self.last_battery_msg_time is None:
        self.last_battery_msg_time = 0.
      if self.SBS_battery_status is None:
        self.SBS_battery_status = 0
      if self.SBS_battery_status_raw is None:
        self.SBS_battery_status_raw = 0
      if self.SBS_serial_1 is None:
        self.SBS_serial_1 = ''
      if self.SBS_serial_2 is None:
        self.SBS_serial_2 = ''
      if self.SBS_arti_nr_1 is None:
        self.SBS_arti_nr_1 = 0
      if self.SBS_arti_nr_2 is None:
        self.SBS_arti_nr_2 = 0
      if self.SBS_arti_nr_3 is None:
        self.SBS_arti_nr_3 = 0
      if self.SBS_curr_flow_passive_state is None:
        self.SBS_curr_flow_passive_state = 0
      if self.CHG_OC1_Count is None:
        self.CHG_OC1_Count = 0
      if self.CHG_OC2_Count is None:
        self.CHG_OC2_Count = 0
      if self.DSG_OC1_Count is None:
        self.DSG_OC1_Count = 0
      if self.DSG_OC2_Count is None:
        self.DSG_OC2_Count = 0
      if self.DSG_OC3_Count is None:
        self.DSG_OC3_Count = 0
      if self.AFE_OC1_Count is None:
        self.AFE_OC1_Count = 0
      if self.AFE_OC2_Count is None:
        self.AFE_OC2_Count = 0
      if self.CHG_LatchClear_Count is None:
        self.CHG_LatchClear_Count = 0
      if self.DSG_LatchClear_Count is None:
        self.DSG_LatchClear_Count = 0
      if self.chg_oc_warning is None:
        self.chg_oc_warning = 0
      if self.dsg_oc_warning is None:
        self.dsg_oc_warning = 0
    else:
      self.pack_voltage = 0.
      self.charge_current = 0.
      self.discharge_current = 0.
      self.state_of_charge = 0.
      self.remaining_time_to_full_charge = 0.
      self.remaining_capacity = 0
      self.state_of_health = 0
      self.status_flags = 0
      self.temperature = 0
      self.cell_voltage = []
      self.cell_voltage_diff = 0
      self.WST_serial = ''
      self.bmz_flag = 0
      self.battery_type = 0
      self.full_voltage = 0.
      self.full_capacity = 0
      self.temperature2 = 0
      self.temperature_pcb = 0
      self.cycle_count = 0
      self.dsg_overcurrent_counter = 0
      self.chg_overcurrent_counter = 0
      self.hw_major = 0
      self.hw_minor = 0
      self.fw_major = 0
      self.fw_minor = 0
      self.fw_patch = 0
      self.fw_parameters_ok = 0
      self.rec_fw_major = 0
      self.rec_fw_minor = 0
      self.rec_fw_patch = 0
      self.bl_major = 0
      self.bl_minor = 0
      self.status_enabled = 0
      self.status_current_limitation = 0
      self.status_switch_off_warn1 = 0
      self.status_switch_off_warn2 = 0
      self.status_fully_discharged = 0
      self.status_nearly_discharged = 0
      self.status_chargefet_on = 0
      self.status_dischargefet_on = 0
      self.status_discharging = 0
      self.status_fully_charged = 0
      self.status_charging = 0
      self.status_temp_charging_err = 0
      self.status_cell_over_voltage = 0
      self.status_cell_under_voltage = 0
      self.status_charge_over_current = 0
      self.status_shortcircuit = 0
      self.status_discharge_over_current = 0
      self.status_chargefet_voltage = 0.
      self.status_dischargefet_voltage = 0.
      self.status_temp_discharging_err = 0
      self.status_charger_detected = 0
      self.mnfct_bms_revision = 0
      self.mnfct_asn_revision = 0
      self.mnfct_year = 0
      self.mnfct_week = 0
      self.mnfct_model = 0
      self.mnfct_serial = 0
      self.afe_i2c_error_count = 0
      self.app_error_count = 0
      self.fet_disable_state = 0
      self.last_battery_msg_time = 0.
      self.SBS_battery_status = 0
      self.SBS_battery_status_raw = 0
      self.SBS_serial_1 = ''
      self.SBS_serial_2 = ''
      self.SBS_arti_nr_1 = 0
      self.SBS_arti_nr_2 = 0
      self.SBS_arti_nr_3 = 0
      self.SBS_curr_flow_passive_state = 0
      self.CHG_OC1_Count = 0
      self.CHG_OC2_Count = 0
      self.DSG_OC1_Count = 0
      self.DSG_OC2_Count = 0
      self.DSG_OC3_Count = 0
      self.AFE_OC1_Count = 0
      self.AFE_OC2_Count = 0
      self.CHG_LatchClear_Count = 0
      self.DSG_LatchClear_Count = 0
      self.chg_oc_warning = 0
      self.dsg_oc_warning = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_5d4i().pack(_x.pack_voltage, _x.charge_current, _x.discharge_current, _x.state_of_charge, _x.remaining_time_to_full_charge, _x.remaining_capacity, _x.state_of_health, _x.status_flags, _x.temperature))
      length = len(self.cell_voltage)
      buff.write(_struct_I.pack(length))
      pattern = '<%sI'%length
      buff.write(struct.Struct(pattern).pack(*self.cell_voltage))
      _x = self.cell_voltage_diff
      buff.write(_get_struct_I().pack(_x))
      _x = self.WST_serial
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2Id17i17I2d11Id2I().pack(_x.bmz_flag, _x.battery_type, _x.full_voltage, _x.full_capacity, _x.temperature2, _x.temperature_pcb, _x.cycle_count, _x.dsg_overcurrent_counter, _x.chg_overcurrent_counter, _x.hw_major, _x.hw_minor, _x.fw_major, _x.fw_minor, _x.fw_patch, _x.fw_parameters_ok, _x.rec_fw_major, _x.rec_fw_minor, _x.rec_fw_patch, _x.bl_major, _x.bl_minor, _x.status_enabled, _x.status_current_limitation, _x.status_switch_off_warn1, _x.status_switch_off_warn2, _x.status_fully_discharged, _x.status_nearly_discharged, _x.status_chargefet_on, _x.status_dischargefet_on, _x.status_discharging, _x.status_fully_charged, _x.status_charging, _x.status_temp_charging_err, _x.status_cell_over_voltage, _x.status_cell_under_voltage, _x.status_charge_over_current, _x.status_shortcircuit, _x.status_discharge_over_current, _x.status_chargefet_voltage, _x.status_dischargefet_voltage, _x.status_temp_discharging_err, _x.status_charger_detected, _x.mnfct_bms_revision, _x.mnfct_asn_revision, _x.mnfct_year, _x.mnfct_week, _x.mnfct_model, _x.mnfct_serial, _x.afe_i2c_error_count, _x.app_error_count, _x.fet_disable_state, _x.last_battery_msg_time, _x.SBS_battery_status, _x.SBS_battery_status_raw))
      _x = self.SBS_serial_1
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.SBS_serial_2
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_4I11B().pack(_x.SBS_arti_nr_1, _x.SBS_arti_nr_2, _x.SBS_arti_nr_3, _x.SBS_curr_flow_passive_state, _x.CHG_OC1_Count, _x.CHG_OC2_Count, _x.DSG_OC1_Count, _x.DSG_OC2_Count, _x.DSG_OC3_Count, _x.AFE_OC1_Count, _x.AFE_OC2_Count, _x.CHG_LatchClear_Count, _x.DSG_LatchClear_Count, _x.chg_oc_warning, _x.dsg_oc_warning))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 56
      (_x.pack_voltage, _x.charge_current, _x.discharge_current, _x.state_of_charge, _x.remaining_time_to_full_charge, _x.remaining_capacity, _x.state_of_health, _x.status_flags, _x.temperature,) = _get_struct_5d4i().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sI'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.cell_voltage = s.unpack(str[start:end])
      start = end
      end += 4
      (self.cell_voltage_diff,) = _get_struct_I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.WST_serial = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.WST_serial = str[start:end]
      _x = self
      start = end
      end += 228
      (_x.bmz_flag, _x.battery_type, _x.full_voltage, _x.full_capacity, _x.temperature2, _x.temperature_pcb, _x.cycle_count, _x.dsg_overcurrent_counter, _x.chg_overcurrent_counter, _x.hw_major, _x.hw_minor, _x.fw_major, _x.fw_minor, _x.fw_patch, _x.fw_parameters_ok, _x.rec_fw_major, _x.rec_fw_minor, _x.rec_fw_patch, _x.bl_major, _x.bl_minor, _x.status_enabled, _x.status_current_limitation, _x.status_switch_off_warn1, _x.status_switch_off_warn2, _x.status_fully_discharged, _x.status_nearly_discharged, _x.status_chargefet_on, _x.status_dischargefet_on, _x.status_discharging, _x.status_fully_charged, _x.status_charging, _x.status_temp_charging_err, _x.status_cell_over_voltage, _x.status_cell_under_voltage, _x.status_charge_over_current, _x.status_shortcircuit, _x.status_discharge_over_current, _x.status_chargefet_voltage, _x.status_dischargefet_voltage, _x.status_temp_discharging_err, _x.status_charger_detected, _x.mnfct_bms_revision, _x.mnfct_asn_revision, _x.mnfct_year, _x.mnfct_week, _x.mnfct_model, _x.mnfct_serial, _x.afe_i2c_error_count, _x.app_error_count, _x.fet_disable_state, _x.last_battery_msg_time, _x.SBS_battery_status, _x.SBS_battery_status_raw,) = _get_struct_2Id17i17I2d11Id2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.SBS_serial_1 = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.SBS_serial_1 = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.SBS_serial_2 = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.SBS_serial_2 = str[start:end]
      _x = self
      start = end
      end += 27
      (_x.SBS_arti_nr_1, _x.SBS_arti_nr_2, _x.SBS_arti_nr_3, _x.SBS_curr_flow_passive_state, _x.CHG_OC1_Count, _x.CHG_OC2_Count, _x.DSG_OC1_Count, _x.DSG_OC2_Count, _x.DSG_OC3_Count, _x.AFE_OC1_Count, _x.AFE_OC2_Count, _x.CHG_LatchClear_Count, _x.DSG_LatchClear_Count, _x.chg_oc_warning, _x.dsg_oc_warning,) = _get_struct_4I11B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_5d4i().pack(_x.pack_voltage, _x.charge_current, _x.discharge_current, _x.state_of_charge, _x.remaining_time_to_full_charge, _x.remaining_capacity, _x.state_of_health, _x.status_flags, _x.temperature))
      length = len(self.cell_voltage)
      buff.write(_struct_I.pack(length))
      pattern = '<%sI'%length
      buff.write(self.cell_voltage.tostring())
      _x = self.cell_voltage_diff
      buff.write(_get_struct_I().pack(_x))
      _x = self.WST_serial
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2Id17i17I2d11Id2I().pack(_x.bmz_flag, _x.battery_type, _x.full_voltage, _x.full_capacity, _x.temperature2, _x.temperature_pcb, _x.cycle_count, _x.dsg_overcurrent_counter, _x.chg_overcurrent_counter, _x.hw_major, _x.hw_minor, _x.fw_major, _x.fw_minor, _x.fw_patch, _x.fw_parameters_ok, _x.rec_fw_major, _x.rec_fw_minor, _x.rec_fw_patch, _x.bl_major, _x.bl_minor, _x.status_enabled, _x.status_current_limitation, _x.status_switch_off_warn1, _x.status_switch_off_warn2, _x.status_fully_discharged, _x.status_nearly_discharged, _x.status_chargefet_on, _x.status_dischargefet_on, _x.status_discharging, _x.status_fully_charged, _x.status_charging, _x.status_temp_charging_err, _x.status_cell_over_voltage, _x.status_cell_under_voltage, _x.status_charge_over_current, _x.status_shortcircuit, _x.status_discharge_over_current, _x.status_chargefet_voltage, _x.status_dischargefet_voltage, _x.status_temp_discharging_err, _x.status_charger_detected, _x.mnfct_bms_revision, _x.mnfct_asn_revision, _x.mnfct_year, _x.mnfct_week, _x.mnfct_model, _x.mnfct_serial, _x.afe_i2c_error_count, _x.app_error_count, _x.fet_disable_state, _x.last_battery_msg_time, _x.SBS_battery_status, _x.SBS_battery_status_raw))
      _x = self.SBS_serial_1
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.SBS_serial_2
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_4I11B().pack(_x.SBS_arti_nr_1, _x.SBS_arti_nr_2, _x.SBS_arti_nr_3, _x.SBS_curr_flow_passive_state, _x.CHG_OC1_Count, _x.CHG_OC2_Count, _x.DSG_OC1_Count, _x.DSG_OC2_Count, _x.DSG_OC3_Count, _x.AFE_OC1_Count, _x.AFE_OC2_Count, _x.CHG_LatchClear_Count, _x.DSG_LatchClear_Count, _x.chg_oc_warning, _x.dsg_oc_warning))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 56
      (_x.pack_voltage, _x.charge_current, _x.discharge_current, _x.state_of_charge, _x.remaining_time_to_full_charge, _x.remaining_capacity, _x.state_of_health, _x.status_flags, _x.temperature,) = _get_struct_5d4i().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sI'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.cell_voltage = numpy.frombuffer(str[start:end], dtype=numpy.uint32, count=length)
      start = end
      end += 4
      (self.cell_voltage_diff,) = _get_struct_I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.WST_serial = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.WST_serial = str[start:end]
      _x = self
      start = end
      end += 228
      (_x.bmz_flag, _x.battery_type, _x.full_voltage, _x.full_capacity, _x.temperature2, _x.temperature_pcb, _x.cycle_count, _x.dsg_overcurrent_counter, _x.chg_overcurrent_counter, _x.hw_major, _x.hw_minor, _x.fw_major, _x.fw_minor, _x.fw_patch, _x.fw_parameters_ok, _x.rec_fw_major, _x.rec_fw_minor, _x.rec_fw_patch, _x.bl_major, _x.bl_minor, _x.status_enabled, _x.status_current_limitation, _x.status_switch_off_warn1, _x.status_switch_off_warn2, _x.status_fully_discharged, _x.status_nearly_discharged, _x.status_chargefet_on, _x.status_dischargefet_on, _x.status_discharging, _x.status_fully_charged, _x.status_charging, _x.status_temp_charging_err, _x.status_cell_over_voltage, _x.status_cell_under_voltage, _x.status_charge_over_current, _x.status_shortcircuit, _x.status_discharge_over_current, _x.status_chargefet_voltage, _x.status_dischargefet_voltage, _x.status_temp_discharging_err, _x.status_charger_detected, _x.mnfct_bms_revision, _x.mnfct_asn_revision, _x.mnfct_year, _x.mnfct_week, _x.mnfct_model, _x.mnfct_serial, _x.afe_i2c_error_count, _x.app_error_count, _x.fet_disable_state, _x.last_battery_msg_time, _x.SBS_battery_status, _x.SBS_battery_status_raw,) = _get_struct_2Id17i17I2d11Id2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.SBS_serial_1 = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.SBS_serial_1 = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.SBS_serial_2 = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.SBS_serial_2 = str[start:end]
      _x = self
      start = end
      end += 27
      (_x.SBS_arti_nr_1, _x.SBS_arti_nr_2, _x.SBS_arti_nr_3, _x.SBS_curr_flow_passive_state, _x.CHG_OC1_Count, _x.CHG_OC2_Count, _x.DSG_OC1_Count, _x.DSG_OC2_Count, _x.DSG_OC3_Count, _x.AFE_OC1_Count, _x.AFE_OC2_Count, _x.CHG_LatchClear_Count, _x.DSG_LatchClear_Count, _x.chg_oc_warning, _x.dsg_oc_warning,) = _get_struct_4I11B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2Id17i17I2d11Id2I = None
def _get_struct_2Id17i17I2d11Id2I():
    global _struct_2Id17i17I2d11Id2I
    if _struct_2Id17i17I2d11Id2I is None:
        _struct_2Id17i17I2d11Id2I = struct.Struct("<2Id17i17I2d11Id2I")
    return _struct_2Id17i17I2d11Id2I
_struct_4I11B = None
def _get_struct_4I11B():
    global _struct_4I11B
    if _struct_4I11B is None:
        _struct_4I11B = struct.Struct("<4I11B")
    return _struct_4I11B
_struct_5d4i = None
def _get_struct_5d4i():
    global _struct_5d4i
    if _struct_5d4i is None:
        _struct_5d4i = struct.Struct("<5d4i")
    return _struct_5d4i
