
"use strict";

let ServiceResponseHeader = require('./ServiceResponseHeader.js');
let SkidDetectionDiff = require('./SkidDetectionDiff.js');
let RobotMode = require('./RobotMode.js');
let WorldModel = require('./WorldModel.js');
let SafetyStatus = require('./SafetyStatus.js');
let Event = require('./Event.js');
let Pendant = require('./Pendant.js');
let Gpio = require('./Gpio.js');
let WebPath = require('./WebPath.js');
let EncoderTestEntry = require('./EncoderTestEntry.js');
let MovingState = require('./MovingState.js');
let ChargingState = require('./ChargingState.js');
let PlanSegments = require('./PlanSegments.js');
let HookExtendedStatus = require('./HookExtendedStatus.js');
let BatteryCurrents = require('./BatteryCurrents.js');
let IOs = require('./IOs.js');
let JoystickVel = require('./JoystickVel.js');
let PowerBoardMotorStatus = require('./PowerBoardMotorStatus.js');
let BMSData = require('./BMSData.js');
let Error = require('./Error.js');
let WorldMap = require('./WorldMap.js');
let MirLocalPlannerPathTypes = require('./MirLocalPlannerPathTypes.js');
let GripperState = require('./GripperState.js');
let ResourcesState = require('./ResourcesState.js');
let ResourcesAcquisition = require('./ResourcesAcquisition.js');
let Encoders = require('./Encoders.js');
let UserPrompt = require('./UserPrompt.js');
let Pose2D = require('./Pose2D.js');
let Events = require('./Events.js');
let StampedEncoders = require('./StampedEncoders.js');
let ExternalRobots = require('./ExternalRobots.js');
let Device = require('./Device.js');
let SoundEvent = require('./SoundEvent.js');
let ExternalRobot = require('./ExternalRobot.js');
let Trolley = require('./Trolley.js');
let BrakeState = require('./BrakeState.js');
let MissionCtrlCommand = require('./MissionCtrlCommand.js');
let MissionCtrlState = require('./MissionCtrlState.js');
let ResourceState = require('./ResourceState.js');
let HookStatus = require('./HookStatus.js');
let SkidDetectionStampedFloat = require('./SkidDetectionStampedFloat.js');
let HookData = require('./HookData.js');
let HeightState = require('./HeightState.js');
let Path = require('./Path.js');
let Serial = require('./Serial.js');
let PlanSegment = require('./PlanSegment.js');
let TimeDebug = require('./TimeDebug.js');
let Twist2D = require('./Twist2D.js');
let RobotStatus = require('./RobotStatus.js');
let RobotState = require('./RobotState.js');
let MirExtra = require('./MirExtra.js');
let LocalMapStat = require('./LocalMapStat.js');
let Proximity = require('./Proximity.js');
let AngleMeasurment = require('./AngleMeasurment.js');
let Devices = require('./Devices.js');
let PalletLifterStatus = require('./PalletLifterStatus.js');
let PrecisionDockingStatus = require('./PrecisionDockingStatus.js');

module.exports = {
  ServiceResponseHeader: ServiceResponseHeader,
  SkidDetectionDiff: SkidDetectionDiff,
  RobotMode: RobotMode,
  WorldModel: WorldModel,
  SafetyStatus: SafetyStatus,
  Event: Event,
  Pendant: Pendant,
  Gpio: Gpio,
  WebPath: WebPath,
  EncoderTestEntry: EncoderTestEntry,
  MovingState: MovingState,
  ChargingState: ChargingState,
  PlanSegments: PlanSegments,
  HookExtendedStatus: HookExtendedStatus,
  BatteryCurrents: BatteryCurrents,
  IOs: IOs,
  JoystickVel: JoystickVel,
  PowerBoardMotorStatus: PowerBoardMotorStatus,
  BMSData: BMSData,
  Error: Error,
  WorldMap: WorldMap,
  MirLocalPlannerPathTypes: MirLocalPlannerPathTypes,
  GripperState: GripperState,
  ResourcesState: ResourcesState,
  ResourcesAcquisition: ResourcesAcquisition,
  Encoders: Encoders,
  UserPrompt: UserPrompt,
  Pose2D: Pose2D,
  Events: Events,
  StampedEncoders: StampedEncoders,
  ExternalRobots: ExternalRobots,
  Device: Device,
  SoundEvent: SoundEvent,
  ExternalRobot: ExternalRobot,
  Trolley: Trolley,
  BrakeState: BrakeState,
  MissionCtrlCommand: MissionCtrlCommand,
  MissionCtrlState: MissionCtrlState,
  ResourceState: ResourceState,
  HookStatus: HookStatus,
  SkidDetectionStampedFloat: SkidDetectionStampedFloat,
  HookData: HookData,
  HeightState: HeightState,
  Path: Path,
  Serial: Serial,
  PlanSegment: PlanSegment,
  TimeDebug: TimeDebug,
  Twist2D: Twist2D,
  RobotStatus: RobotStatus,
  RobotState: RobotState,
  MirExtra: MirExtra,
  LocalMapStat: LocalMapStat,
  Proximity: Proximity,
  AngleMeasurment: AngleMeasurment,
  Devices: Devices,
  PalletLifterStatus: PalletLifterStatus,
  PrecisionDockingStatus: PrecisionDockingStatus,
};
